<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
    // Exit if accessed directly
}


if ( function_exists( 'wga_fs' ) ) {
    wga_fs()->set_basename( true, __FILE__ );
} else {
    // DO NOT REMOVE THIS IF, IT IS ESSENTIAL FOR THE `function_exists` CALL ABOVE TO PROPERLY WORK.
    
    if ( !function_exists( 'wga_fs' ) ) {
        // Create a helper function for easy SDK access.
        function wga_fs()
        {
            global  $wga_fs ;
            
            if ( !isset( $wga_fs ) ) {
                // Include Freemius SDK.
                //                require_once dirname(__FILE__) . '/freemius/start.php';
                require_once dirname( __FILE__ ) . '/vendor/freemius/wordpress-sdk/start.php';
                $wga_fs = fs_dynamic_init( [
                    'navigation'      => 'tabs',
                    'id'              => '7498',
                    'slug'            => 'woocommerce-google-adwords-conversion-tracking-tag',
                    'premium_slug'    => 'woopt-pixel-manager-pro',
                    'type'            => 'plugin',
                    'public_key'      => 'pk_d4182c5e1dc92c6032e59abbfdb91',
                    'is_premium'      => false,
                    'premium_suffix'  => 'Pro',
                    'has_addons'      => false,
                    'has_paid_plans'  => true,
                    'trial'           => [
                    'days'               => 14,
                    'is_require_payment' => true,
                ],
                    'has_affiliation' => 'customers',
                    'menu'            => [
                    'slug'           => 'wgact',
                    'override_exact' => true,
                    'contact'        => false,
                    'support'        => false,
                    'parent'         => [
                    'slug' => 'woocommerce',
                ],
                ],
                    'is_live'         => true,
                ] );
            }
            
            return $wga_fs;
        }
        
        // Init Freemius.
        wga_fs();
        // Signal that SDK was initiated.
        do_action( 'wga_fs_loaded' );
        function wga_fs_settings_url()
        {
            return admin_url( 'admin.php?page=wgact&section=main&subsection=google-ads' );
        }
        
        wga_fs()->add_filter( 'connect_url', 'wga_fs_settings_url' );
        wga_fs()->add_filter( 'after_skip_url', 'wga_fs_settings_url' );
        wga_fs()->add_filter( 'after_connect_url', 'wga_fs_settings_url' );
        wga_fs()->add_filter( 'after_pending_connect_url', 'wga_fs_settings_url' );
    }
    
    // ... Your plugin's main file logic ...
    new WGACT();
}
